require_dependency 'queries_helper'

module UsabillityImprovementQueriesHelperPatch
  
  def self.included(base) # :nodoc:
    
      base.send(:include, InstanceMethods)     
      base.class_eval do
        alias_method_chain :column_value, :inline_edit
      end
      
  end

  module  InstanceMethods
    
    def column_value_with_inline_edit(column, issue, value)
      case value.class.name
      when 'String'
        if column.name == :subject
          link_to(h(value), :controller => 'issues', :action => 'show', :id => issue)
        else
          h(value)
        end
      when 'Time'
        format_time(value)
      when 'Date'
        if column.name == :due_date && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_due_date_field'}, @project, :global => false)
          link_to_remote((format_date(issue.due_date)), :url => {:controller => 'issues', :action => 'show_due_date_field', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-due_date") 
        else 
          format_date(value)
        end
      when 'Fixnum', 'Float'
        if column.name == :done_ratio
          progress_bar(value, :width => '80px')
        elsif  column.name == :spent_hours
          if User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_spent_hours_field'}, @project, :global => false) && User.current.allowed_to?(:log_time, @project)
            link_to_remote((sprintf "%.2f", issue.spent_hours), :url => {:controller => 'issues', :action => 'show_spent_hours_field', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-spent_hours") 
          else 
            sprintf "%.2f", value
          end
        elsif  column.name == :estimated_hours
          if User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_estimated_hours_field'}, @project, :global => false)
            link_to_remote((sprintf "%.2f", issue.estimated_hours), :url => {:controller => 'issues', :action => 'show_estimated_hours_field', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-estimated_hours") 
          else 
            sprintf "%.2f", value
          end
        else
          h(value.to_s)
        end
      when 'User'
        if column.name == :assigned_to && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_assignee_list'}, @project, :global => false)
          link_to_remote((issue.assigned_to.name), :url => {:controller => 'issues', :action => 'show_assignee_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-assigned_to") 
        else 
          link_to_user value
        end
      when 'Project'
        link_to_project value
      when 'Version'
        if column.name == :fixed_version && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_fixed_version_list'}, @project, :global => false)
          link_to_remote((issue.fixed_version.name), :url => {:controller => 'issues', :action => 'show_fixed_version_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-fixed_version") 
        else 
          link_to(h(value), :controller => 'versions', :action => 'show', :id => value)
        end
      when 'TrueClass'
        l(:general_text_Yes)
      when 'FalseClass'
        l(:general_text_No)
      when 'Issue'
        link_to_issue(value, :subject => false)
      when 'IssueStatus'
        if column.name == :status && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_status_list'}, @project, :global => false)
          link_to_remote((issue.status.name), :url => {:controller => 'issues', :action => 'show_status_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-status") 
        else 
          h(value)
        end
      when 'Tracker'
        if column.name == :tracker && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_tracker_list'}, @project, :global => false)
          link_to_remote((issue.tracker.name), :url => {:controller => 'issues', :action => 'show_tracker_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-tracker") 
        else 
          h(value)
        end
      when 'IssuePriority'
        if column.name == :priority && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_priority_list'}, @project, :global => false)
          link_to_remote((issue.priority.name), :url => {:controller => 'issues', :action => 'show_priority_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-priority") 
        else 
          h(value)
        end
      else
        if column.name == :assigned_to && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_assignee_list'}, @project, :global => false)
          link_to_remote((l(:not_defined)), :url => {:controller => 'issues', :action => 'show_assignee_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-assigned_to") 
        elsif column.name == :fixed_version && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_fixed_version_list'}, @project, :global => false)
          link_to_remote((l(:not_defined)), :url => {:controller => 'issues', :action => 'show_fixed_version_list', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-fixed_version") 
        elsif column.name == :due_date && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_due_date_field'}, @project, :global => false)
          link_to_remote((l(:not_defined)), :url => {:controller => 'issues', :action => 'show_due_date_field', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-due_date") 
        elsif column.name == :estimated_hours && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_estimated_hours_field'}, @project, :global => false)
          link_to_remote((l(:not_defined)), :url => {:controller => 'issues', :action => 'show_estimated_hours_field', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-estimated_hours") 
        elsif column.name == :spent_hours && User.current && User.current.allowed_to?({:controller => 'issues', :action => 'show_spent_hours_field'}, @project, :global => false) && User.current.allowed_to?(:log_time, @project)
          link_to_remote((l(:not_defined)), :url => {:controller => 'issues', :action => 'show_spent_hours_field', :id => issue, :project_id => issue.project }, :update => "#{issue.id}-spent_hours") 
        else    
          h(value)
        end
      end
    end
    
  end
  
end

QueriesHelper.send(:include, UsabillityImprovementQueriesHelperPatch)